<?php
/**
 * Plugin Name: Get Affiliate Link
 * Version: 1.5.13
 * Plugin URI: http://www.getaffiliatelink.com
 * Description: Effortless updating. Always show the latest price to your visitors.
 * Author: GetAffiliateLink.com
 * Author URI: https://www.getaffiliatelink.com/
 * Requires at least: 4.0
 * Tested up to: 4.0
 *
 * Text Domain: get-affiliate-link
 * Domain Path: /lang/
 *
 * @package get-affiliate-link
 * @author GetAffiliateLink.com
 * @since 1.0.0
 */

if ( ! defined( 'ABSPATH' ) ) { exit; }

// Load plugin class files.
require_once( 'includes/class-get-affiliate-link.php' );
require_once( 'includes/class-get-affiliate-link-product-table.php' );
require_once( 'includes/class-get-affiliate-link-products.php' );
require_once( 'includes/class-get-affiliate-link-settings.php' );
//
// Load plugin libraries.
require_once( 'includes/lib/class-get-affiliate-link-admin-api.php' );
require_once( 'includes/lib/class-get-affiliate-link-product-list-table.php' );
require_once( 'includes/lib/class-get-affiliate-link-product.php' );
require_once( 'includes/lib/class-get-affiliate-link-product-form-processor.php' );
// @codingStandardsIgnoreStart
// require_once('includes/lib/class-get-affiliate-link-tinymce-widget.php');
// @codingStandardsIgnoreEnd
require_once( 'includes/lib/get-affiliate-link-outbound.php' );
require_once( 'includes/lib/get-affiliate-link-path-checker.php' );

define( 'GAL_PLUGIN_VERSION','1.5.13' );
define( 'GAL_PLUGIN_NAME','get-affiliate-link' );
define( 'GAL_PATH',WP_PLUGIN_DIR . '/' . GAL_PLUGIN_NAME );
define( 'GAL_VIEWS_PATH',GAL_PATH . '/includes/views' );
define( 'GAL_PRODUCTS_TABLE','get_affiliate_link' );

/**
 * Returns the main instance of get_affiliate_link to prevent the need to use globals.
 *
 * @since  1.0.0
 * @return object get_affiliate_link.
 */
function get_affiliate_link() {
	$instance = get_affiliate_link::instance( __FILE__, GAL_PLUGIN_VERSION );

	if ( null === $instance->settings ) {
		$instance->settings = get_affiliate_link_Settings::instance( $instance );
	}

	return $instance;
}

get_affiliate_link();
