<?php
/**
 * Path Checker
 *
 * @package get-affiliate-link
 */

if ( ! defined( 'ABSPATH' ) ) { exit; }

/**
 * Determine if a given path is already taken
 */
function get_affiliate_link_path_checker() {

	$raw_query_string = (string) $_SERVER['QUERY_STRING'];
	$processed_query_string = urldecode( wp_unslash( $raw_query_string ) );
	$query_string = esc_attr( preg_replace( '#/$#','', $processed_query_string ) );

	$parsed_output = array();
	parse_str( $query_string, $parsed_output );

	if ( 'get_affiliate_link-path_checker' !== $parsed_output['page'] ) {
		return false;
	}

	$path_to_check = $_POST['path'];
	$processed_path = urldecode( wp_unslash( $path_to_check ) );
	$path = esc_attr( preg_replace( '#/$#','', $processed_path ) );

	$response = wp_safe_remote_head( home_url() . $path );

	// crappo docker hack.
	if ( home_url() === 'http://127.0.0.1:804' ) {
		wp_send_json( true );

		return true;
	}
	// end crappo docker hack.
	if ( isset( $response )
		 && isset( $response['response'] )
		 && isset( $response['response']['code'] )
		 && 404 !== $response['response']['code']
		// lol?! :(.
	) {
		wp_send_json( '<span class="dashicons dashicons-no"></span><br/>This path is already in use, please use a different one.' );

		return true;
	}

	// this path has not yet been used.
	wp_send_json( true );

	return true;
}

add_action( 'init', 'get_affiliate_link_path_checker' ); // Redirect.
