function pollServer(maxRetries, url, success, fail, timeout) {
  if (parseInt(maxRetries) <= 0) {
    return false;
  }

  if (typeof timeout === "undefined") {
    timeout = 2500;
  }

  window.setTimeout(
    function() {
      jQuery
        .ajax({
          url: url
        })
        .done(function(product) {
          if (product.data.length === 0) {
            return tryAgain();
          }

          success(product);

          pollServer(0);
        })
        .fail(function(jqXHR, textStatus, errorThrown) {
          fail(jqXHR, textStatus, errorThrown);

          return tryAgain();
        });
    },
    timeout
  );

  function tryAgain() {
    pollServer(--maxRetries, url, success, fail, 3000);
  }
}
